--- old/usr/src/uts/common/fs/zfs/dmu_tx.c	Fri Aug  2 13:20:52 2013
+++ new/usr/src/uts/common/fs/zfs/dmu_tx.c	Fri Aug  2 13:20:52 2013
@@ -448,12 +448,12 @@
 		blkid = off >> dn->dn_datablkshift;
 		nblks = (len + dn->dn_datablksz - 1) >> dn->dn_datablkshift;
 
-		if (blkid >= dn->dn_maxblkid) {
+		if (blkid > dn->dn_maxblkid) {
 			rw_exit(&dn->dn_struct_rwlock);
 			return;
 		}
 		if (blkid + nblks > dn->dn_maxblkid)
-			nblks = dn->dn_maxblkid - blkid;
+			nblks = dn->dn_maxblkid - blkid + 1;
 
 	}
 	l0span = nblks;    /* save for later use to calc level > 1 overhead */
